/*
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright 2015-2019 Andres Almiray
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.kordamp.ikonli.fontawesome5;

import org.kordamp.ikonli.Ikon;

/**
 * @author Andres Almiray
 */
public enum FontAwesomeRegular implements Ikon {
    ADDRESS_BOOK("far-address-book", '\uf2b9'),
    ADDRESS_CARD("far-address-card", '\uf2bb'),
    ARROW_ALT_CIRCLE_DOWN("far-arrow-alt-circle-down", '\uf358'),
    ARROW_ALT_CIRCLE_LEFT("far-arrow-alt-circle-left", '\uf359'),
    ARROW_ALT_CIRCLE_RIGHT("far-arrow-alt-circle-right", '\uf35a'),
    ARROW_ALT_CIRCLE_UP("far-arrow-alt-circle-up", '\uf35b'),
    BELL("far-bell", '\uf0f3'),
    BELL_SLASH("far-bell-slash", '\uf1f6'),
    BOOKMARK("far-bookmark", '\uf02e'),
    BUILDING("far-building", '\uf1ad'),
    CALENDAR("far-calendar", '\uf133'),
    CALENDAR_ALT("far-calendar-alt", '\uf073'),
    CALENDAR_CHECK("far-calendar-check", '\uf274'),
    CALENDAR_MINUS("far-calendar-minus", '\uf272'),
    CALENDAR_PLUS("far-calendar-plus", '\uf271'),
    CALENDAR_TIMES("far-calendar-times", '\uf273'),
    CARET_SQUARE_DOWN("far-caret-square-down", '\uf150'),
    CARET_SQUARE_LEFT("far-caret-square-left", '\uf191'),
    CARET_SQUARE_RIGHT("far-caret-square-right", '\uf152'),
    CARET_SQUARE_UP("far-caret-square-up", '\uf151'),
    CHART_BAR("far-chart-bar", '\uf080'),
    CHECK_CIRCLE("far-check-circle", '\uf058'),
    CHECK_SQUARE("far-check-square", '\uf14a'),
    CIRCLE("far-circle", '\uf111'),
    CLIPBOARD("far-clipboard", '\uf328'),
    CLOCK("far-clock", '\uf017'),
    CLONE("far-clone", '\uf24d'),
    CLOSED_CAPTIONING("far-closed-captioning", '\uf20a'),
    COMMENT("far-comment", '\uf075'),
    COMMENT_ALT("far-comment-alt", '\uf27a'),
    COMMENTS("far-comments", '\uf086'),
    COMPASS("far-compass", '\uf14e'),
    COPY("far-copy", '\uf0c5'),
    COPYRIGHT("far-copyright", '\uf1f9'),
    CREDIT_CARD("far-credit-card", '\uf09d'),
    DOT_CIRCLE("far-dot-circle", '\uf192'),
    EDIT("far-edit", '\uf044'),
    ENVELOPE("far-envelope", '\uf0e0'),
    ENVELOPE_OPEN("far-envelope-open", '\uf2b6'),
    EYE_SLASH("far-eye-slash", '\uf070'),
    FILE("far-file", '\uf15b'),
    FILE_ALT("far-file-alt", '\uf15c'),
    FILE_ARCHIVE("far-file-archive", '\uf1c6'),
    FILE_AUDIO("far-file-audio", '\uf1c7'),
    FILE_CODE("far-file-code", '\uf1c9'),
    FILE_EXCEL("far-file-excel", '\uf1c3'),
    FILE_IMAGE("far-file-image", '\uf1c5'),
    FILE_PDF("far-file-pdf", '\uf1c1'),
    FILE_POWERPOINT("far-file-powerpoint", '\uf1c4'),
    FILE_VIDEO("far-file-video", '\uf1c8'),
    FILE_WORD("far-file-word", '\uf1c2'),
    FLAG("far-flag", '\uf024'),
    FOLDER("far-folder", '\uf07b'),
    FOLDER_OPEN("far-folder-open", '\uf07c'),
    FROWN("far-frown", '\uf119'),
    FUTBOL("far-futbol", '\uf1e3'),
    GEM("far-gem", '\uf3a5'),
    HAND_LIZARD("far-hand-lizard", '\uf258'),
    HAND_PAPER("far-hand-paper", '\uf256'),
    HAND_PEACE("far-hand-peace", '\uf25b'),
    HAND_POINT_DOWN("far-hand-point-down", '\uf0a7'),
    HAND_POINT_LEFT("far-hand-point-left", '\uf0a5'),
    HAND_POINT_RIGHT("far-hand-point-right", '\uf0a4'),
    HAND_POINT_UP("far-hand-point-up", '\uf0a6'),
    HAND_POINTER("far-hand-pointer", '\uf25a'),
    HAND_ROCK("far-hand-rock", '\uf255'),
    HAND_SCISSORS("far-hand-scissors", '\uf257'),
    HAND_SPOCK("far-hand-spock", '\uf259'),
    HANDSHAKE("far-handshake", '\uf2b5'),
    HDD("far-hdd", '\uf0a0'),
    HEART("far-heart", '\uf004'),
    HOSPITAL("far-hospital", '\uf0f8'),
    HOURGLASS("far-hourglass", '\uf254'),
    ID_BADGE("far-id-badge", '\uf2c1'),
    ID_CARD("far-id-card", '\uf2c2'),
    IMAGE("far-image", '\uf03e'),
    IMAGES("far-images", '\uf302'),
    KEYBOARD("far-keyboard", '\uf11c'),
    LEMON("far-lemon", '\uf094'),
    LIFE_RING("far-life-ring", '\uf1cd'),
    LIGHTBULB("far-lightbulb", '\uf0eb'),
    LIST_ALT("far-list-alt", '\uf022'),
    MAP("far-map", '\uf279'),
    MEH("far-meh", '\uf11a'),
    MINUS_SQUARE("far-minus-square", '\uf146'),
    MONEY_BILL_ALT("far-money-bill-alt", '\uf3d1'),
    MOON("far-moon", '\uf186'),
    NEWSPAPER("far-newspaper", '\uf1ea'),
    OBJECT_GROUP("far-object-group", '\uf247'),
    OBJECT_UNGROUP("far-object-ungroup", '\uf248'),
    PAPER_PLANE("far-paper-plane", '\uf1d8'),
    PAUSE_CIRCLE("far-pause-circle", '\uf28b'),
    PLAY_CIRCLE("far-play-circle", '\uf144'),
    PLUS_SQUARE("far-plus-square", '\uf0fe'),
    QUESTION_CIRCLE("far-question-circle", '\uf059'),
    REGISTERED("far-registered", '\uf25d'),
    SAVE("far-save", '\uf0c7'),
    SHARE_SQUARE("far-share-square", '\uf14d'),
    SMILE("far-smile", '\uf118'),
    SNOWFLAKE("far-snowflake", '\uf2dc'),
    SQUARE("far-square", '\uf0c8'),
    STAR("far-star", '\uf005'),
    STAR_HALF("far-star-half", '\uf089'),
    STICKY_NOTE("far-sticky-note", '\uf249'),
    STOP_CIRCLE("far-stop-circle", '\uf28d'),
    SUN("far-sun", '\uf185'),
    THUMBS_DOWN("far-thumbs-down", '\uf165'),
    THUMBS_UP("far-thumbs-up", '\uf164'),
    TIMES_CIRCLE("far-times-circle", '\uf057'),
    TRASH_ALT("far-trash-alt", '\uf2ed'),
    USER("far-user", '\uf007'),
    USER_CIRCLE("far-user-circle", '\uf2bd'),
    WINDOW_CLOSE("far-window-close", '\uf410'),
    WINDOW_MAXIMIZE("far-window-maximize", '\uf2d0'),
    WINDOW_RESTORE("far-window-restore", '\uf2d2');

    public static FontAwesomeRegular findByDescription(String description) {
        for (FontAwesomeRegular font : values()) {
            if (font.getDescription().equals(description)) {
                return font;
            }
        }
        throw new IllegalArgumentException("Icon description '" + description + "' is invalid!");
    }

    private String description;
    private char code;

    FontAwesomeRegular(String description, char code) {
        this.description = description;
        this.code = code;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public char getCode() {
        return code;
    }
}